// Copyright (c) 2020, the R8 project authors. Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

package com.android.tools.r8.horizontalclassmerging.policies;

import com.android.tools.r8.graph.AppView;
import com.android.tools.r8.graph.DexProgramClass;
import com.android.tools.r8.horizontalclassmerging.SingleClassPolicy;
import com.android.tools.r8.shaking.AppInfoWithLiveness;
import com.android.tools.r8.shaking.MainDexInfo;

public class PreventMergeIntoMainDexList extends SingleClassPolicy {

  private final MainDexInfo mainDexInfo;

  public PreventMergeIntoMainDexList(AppView<AppInfoWithLiveness> appView) {
    this.mainDexInfo = appView.appInfo().getMainDexInfo();
  }

  @Override
  public boolean canMerge(DexProgramClass program) {
    return mainDexInfo.canMerge(program);
  }
}
